package com.tutego.exercise.jdbc;

import java.sql.*;
import java.util.Arrays;
import java.util.List;

public class PreparedInsert {
  public static void main( String[] args ) throws SQLException {
    // CreateTable.main( args );
    //tag::solution[]
    String preparedSql = "INSERT INTO Pirate " +
                         "(nickname, email, swordlength, birthdate, description) " +
                         "VALUES (?, ?, ?, ?, ?)";

    String jdbcUrl = "jdbc:h2:./pirates-dating";
    try ( Connection connection  = DriverManager.getConnection( jdbcUrl );
          PreparedStatement stmt = connection.prepareStatement( preparedSql ) ) {

      connection.setAutoCommit( false );

      List<String[]> data = Arrays.asList(
          new String[]{ "jacky overflow", "bullet@jennyblackbeard.red", "17",
                        "1976-12-17", "If love a crime" },
          new String[]{ "IvyIcon", "array.field@graceobool.cool", "12",
                        "1980-06-12", "U&I" },
          new String[]{ "Lulu De Sea", "arielle@dirtyanne.fail", "13",
                        "1983-11-24", "You can be my prince" }
      );

      for ( String[] elements : data ) {
        stmt.setString( /* nickname    */ 1, elements[ 0 ] );
        stmt.setString( /* email       */ 2, elements[ 1 ] );
        stmt.setInt(    /* swordlength */ 3, Integer.parseInt( elements[ 2 ] ) );
        stmt.setDate(   /* birthdate   */ 4, Date.valueOf( elements[ 3 ] ) );
        stmt.setObject( /* description */ 5, elements[ 4 ] );
        stmt.executeUpdate();
      }

      connection.commit();
    }
    //end::solution[]
  }
}